<p align="center">
  <img src="https://gorillajs-web.s3.amazonaws.com/main-files/uploads/2017/08/logo_beta.png" alt="GorillaJS logo"/>
</p>

## Gorilla JS
A smart development environment designed to easily install and neatly manage web applications

** Say hello to the new ways **
Gorilla JS frees you from the repetitive daily tasks like apps installation, database management, creation of virtual environment, server configuration… And it keeps your projects in order and independents. 

### Features
#### Multiplatform
It’s available for Windows, Mac and Linux. You’ll be able to use your projects in any platform wherever you have created them.
#### Local and remote
Your projects work in any machine with Docker and NodeJS. It doesn’t matter if it’s in your personal computer or in a remote server. 
#### CLI
GorillaJS is developing in NodeJS and it uses the command line to communicate with humans. 
#### Multitechnology
You can create installers for any app which works in a Linux server. 
#### Docker
GorillaJS is based on Docker’s container technology. If you haven’t heard about it, don’t worry. You only will need to know how to install it.
#### Easy to use 
Using GorillaJS is very easy. You only need to answer a few questions and your app will be ready. 

### Installers
The installer is the foundation of your project. A stencil in which you can build your app. There’re installers for WordPress , Django, NodeJS… and you can also create a custom one.

#### Django
This installer allows you to produce Django’s projects fast and easily, and manage them in an orderly and independent way without needing to create virtual environments. In a few seconds your app will be ready to start to work. And with the plugins for GorillaJS you’ll be able to back up, install PIP and system packages and share the project with others developers. 
#### WordPress
This installer allows you to generate WordPress’s projects easily without need to configure database, access permissions or install libraries again and again. In a few seconds WordPress will be ready to start to work. With the plugins for GorillaJS you’ll be able to manage and back up of database easily, share the project with others developers, install ….. and a lot more.
#### PHP 7
This installer for GorillaJS allows you to generate a blank project which serves as a foundation of apps like Laravel, Symfony, CakePHP, etc., whose need PHP 7 to work.
#### Create your own installer
If the installers of GorillaJS don’t adapt to your needs you can follow this tutorial step-by-step in order to learn how to create your own installers. 

### Plugins
Plugins add extra usefulness to your project. With them you can manage your database, turn on https, share your project with others developers, install new libraries… 

#### DB for Django 
With the plugins for GorillaJS you’ll be able to add PostgreSQL and MySQL databases to your Django’s projects easily and without need to configure or manage Docker containers. 
#### kDjango manage
With this plugin you’ll be able to manage Django with manage.py in an easy way and install and manage Python3 packages, as well as saving automatically the changes in the container so as not to lose them the next time you start the project. And all of this without needing to access to Docker’s container. 
#### Extra packages
With this plugin for GorillaJS you’ll be able to install and manage easily Linux packages (apt, apk,…) in your projects. It’s compatible with the most popular manager: apt, apk, pacman y yum.
#### Composer & PEAR
With this plugin you’ll be able to install and manage the php dependences in your projects created with GorillaJS. You can install libraries and Composer, PEAR and PECL packages. 
#### DB for PHP7
WIth this plugin you’ll be able to add a database in any of your projects created with the PHP7 stencil.
#### Commit
It saves the changes you had done in Docker’s container.
#### DB manager
With this plugin for GorillaJS you’ll be able to manage the basic tasks with your database in an easy and fast way. With just a command you’ll be able to export, import or replace data from the database which your project uses.
#### Let’s Encrypt
With this plugin for GorillaJS you’ll be able to create and refresh certificates issues by Let’s Encrypt easily and turn on the insured navigation in your projects. 
####Adminer
Adminer is a powerful database sysadmin with graphical interface. It’s compatible with the most of actual technologies. This plugin for GorillaJS creates an Adminer’s court in which of your projects in order that you could manage your database easily.
#### Team
Team is a plugin for GorillaJS whose work is make a copy of all the files, databases and images that your project use and it send to the cloud so that you could share it with others team members. GorillaJS takes charge of everything. You only have to choose the project you want to share. 

#### Documentation
Please, visit [gorillajs.com](https://gorillajs.com).
